%% clear
clc;
clear;
close all;
format compact;
format short g;

%% inital stuff
fem = getInitFem;
prob.fem.dof = getDof(fem);

prob.theta(1).fun = @(mu) mu(1);
prob.theta(2).fun = @(mu) mu(2);

prob = performPreAssembling(fem,prob);

%% example for solving
mu = [.1;1]

tic; uCom = getSol(prob,mu,fem); toc
tic; uPre = getSol(prob,mu); toc

figure(1)
fem.sol = femsol(uCom);
subplot(1,3,1); postplot(fem,'tridata','u');

fem.sol = femsol(uPre);
subplot(1,3,2); postplot(fem,'tridata','u');

fem.sol = femsol(abs(uPre-uCom));
subplot(1,3,3); postplot(fem,'tridata','u');

%% compute matrices for discrete inner product
[fem.const{2:2:end}] = deal(1);
[C,D] = assemble(fem,'Out',{'C','D'});

L2 = D;
L2 = (L2+L2')/2;

H1 = C+D;
H1 = (H1+H1')/2;

prob.fem.innProd.L2 = L2;
prob.fem.innProd.H1 = H1;

% % example for intended usage
% norm_X = 'L2';
% figure(2);
% spy(prob.fem.innProd.(norm_X));

%% Aufgabe 1: POD

% parameter space w.r.t. \mu_1
D = [.01 100];

% number of snapshots n_train=2^j_train+1
j_train = 7;
n_train = 2^j_train + 1;

% parameter training set
Xi_train = [logspace(log10(D(1)),log10(D(2)),2^j_train+1); ...
            ones(1,2^j_train+1)];
        
% ====== TBD =====

% construct: Psi = matrix of POD eigenvectors
%            Lambda = POD eigenvalues


%% plot POD basis functions
% figure(3);
% for l=1:size(Psi,2)
%   fem.sol = femsol(Psi(:,l));
%   postplot(fem,'tridata','u');
%   title(num2str(l,'l = %d'));
%   pause;
% end

%% Aufgabe 2: compute projection error for different truncations

% ====== TBD =====

%% Aufgabe 3: compute POD error in dependency of n_train

% ====== TBD =====

